                 LIST P=16F628
                 __CONFIG H'3F70'
W                EQU             0
F                EQU             1
INDF             EQU             00H
TMR0             EQU             01H
TMR2             EQU             11H
T2CON            EQU             12H
PR2              EQU             12H
STATUS           EQU             03H
FSR              EQU             04H
PORTA            EQU             05H
PORTB            EQU             06H
INTCON           EQU             0BH
CMCON            EQU             1FH
CCPR1L           EQU             15H
CCP1CON          EQU             17H
OPTION_REG       EQU             01H
TRISA            EQU             05H
TRISB            EQU             06H
EEDATA           EQU             1AH
EEADR            EQU             1BH
EECON1           EQU             1CH
EECON2           EQU             1DH
PIR1             EQU             0CH
IRP              EQU             7
RP0              EQU             5
Z                EQU             2
C                EQU             0
DC               EQU             1
GIE              EQU             7
T0IE             EQU             5
T0IF             EQU             2
EEIF             EQU             7
WREN             EQU             2
WR               EQU             1
RD               EQU             0
INTE             EQU             4
INTF             EQU             1
;
T1               EQU             20H
T2               EQU             21H
T3               EQU             22H
POWER            EQU             23H
MODE             EQU             24H
N                EQU             25H
OUTA             EQU             26H
J                EQU             27H
K                EQU             28H
W_TMP            EQU             29H
STATUS_TMP       EQU             2AH
DEL1             EQU             2BH
ADR              EQU             2CH
W_TMP2           EQU             2DH
DEL2             EQU             2EH
;
                 ORG             2100H
                 DE              H'41',H'64',H'8C'
                 ORG             0000
                 GOTO            INIT
                 ORG             0004
                 GOTO            CLOCK
INIT             MOVLW           02
                 MOVWF           MODE
                 MOVLW           01
                 CALL            READ
                 MOVWF           POWER
                 MOVLW           7
                 MOVWF           T2CON            ;  2
                 BSF             STATUS,RP0
                 MOVLW           H'C7'
                 MOVWF           OPTION_REG
                 MOVLW           H'B4'
                 MOVWF           PR2              ;  
                 BCF             STATUS,RP0
                 MOVF            POWER,W
                 MOVWF           CCPR1L           ;  
                 MOVLW           H'0F'
                 MOVWF           CCP1CON          ; 
                 MOVLW           7
                 MOVWF           CMCON            ; 
                 BSF             STATUS,RP0
                 CLRF            TRISA
                 MOVLW           7
                 MOVWF           TRISB            ; 
                 BCF             STATUS,RP0
                 CALL            REWRITE          ; 1...3
                 MOVLW           08
                 MOVWF           DEL1
                 BSF             INTCON,T0IE
                 BSF             INTCON,INTE
                 BSF             INTCON,GIE       ; 
                 MOVLW           H'20'
                 MOVWF           N
;
WORK             CLRF            PORTA            ;     
                 MOVF            N,W
                 MOVWF           FSR
                 MOVF            INDF,W
                 MOVWF           PORTB
                 ANDLW           7
                 MOVWF           OUTA
                 MOVF            MODE,W
                 SUBLW           1
                 BTFSC           STATUS,Z
                 BSF             OUTA,7           ;  1 ( HL3)
                 MOVF            MODE,W
                 SUBLW           2
                 BTFSC           STATUS,Z
                 BSF             OUTA,6           ;  2 ( HL2)
                 MOVF            MODE,W
                 SUBLW           3
                 BTFSC           STATUS,Z
                 BSF             OUTA,3           ;  3 ( HL1)
                 MOVF            OUTA,W
                 MOVWF           PORTA
                 MOVLW           H'FF'
                 MOVWF           J
WAIT             DECFSZ          J,F
                 GOTO            WAIT
                 INCF            N,F
                 MOVF            N,W
                 SUBLW           H'23'
                 BTFSS           STATUS,Z
                 GOTO            WORK
                 MOVLW           H'20'
                 MOVWF           N
                 GOTO            WORK
;
REWRITE          CLRF            T1               ;  1...3
                 CLRF            T2
                 CLRF            T3
                 MOVF            POWER,W
                 MOVWF           K
                 INCF            K,F
M1               DECFSZ          K,F
                 GOTO            M2
                 GOTO            END_RW
M2               INCF            T3,F           
                 MOVF            T3,W
                 BCF             STATUS,DC
                 ADDLW           06H
                 BTFSS           STATUS,DC
                 GOTO            M1
                 CLRF            T3
                 INCF            T2,F
                 MOVF            T2,W
                 BCF             STATUS,DC
                 ADDLW           06H
                 BTFSS           STATUS,DC
                 GOTO            M1
                 CLRF            T2
                 INCF            T1,F
                 MOVF            T1,W
                 BCF             STATUS,DC
                 ADDLW           06H
                 BTFSS           STATUS,DC
                 GOTO            M1
                 CLRF            T1
                 GOTO            M1
END_RW           RLF             T1,F
                 RLF             T1,F
                 RLF             T1,F
                 RLF             T1,F
                 BSF             T1,0
                 RLF             T2,F
                 RLF             T2,F
                 RLF             T2,F
                 RLF             T2,F
                 BSF             T2,1
                 RLF             T3,F
                 RLF             T3,F
                 RLF             T3,F
                 RLF             T3,F
                 BSF             T3,2
                 RETURN
;
READ             BSF             STATUS,RP0         ;   EEPROM
                 MOVWF           EEADR
                 BSF             EECON1,RD
                 MOVF            EEDATA,W
                 BCF             STATUS,RP0
                 RETURN
;
CLOCK            MOVWF           W_TMP              ; 
                 SWAPF           STATUS,W
                 BCF             STATUS,RP0
                 MOVWF           STATUS_TMP
                 BTFSS           INTCON,INTF        ;  SB1-SB3
                 GOTO            SEC05
                 MOVLW           H'15'              ;    
                 MOVWF           DEL2
WAIT2            DECFSZ          DEL2,F
                 GOTO            WAIT2
                 BCF             INTCON,INTF
                 BTFSS           PORTB,0
                 GOTO            ENDCLOCK            ;      0    -  
                 BTFSS           OUTA,0
                 GOTO            M3
                 MOVLW           01
                 MOVWF           MODE               ;  1
                 MOVLW           00
                 CALL            READ
                 MOVWF           POWER
                 MOVWF           CCPR1L             ; 
                 CALL            REWRITE            ; 1...3
M3               BTFSS           OUTA,1
                 GOTO            M4
                 MOVLW           02
                 MOVWF           MODE               ;  2
                 MOVLW           01
                 CALL            READ
                 MOVWF           POWER
                 MOVWF           CCPR1L             ; 
                 CALL            REWRITE            ; 1...3
M4               BTFSS           OUTA,2
                 GOTO            SEC05
                 MOVLW           03
                 MOVWF           MODE               ;  3
                 MOVLW           02
                 CALL            READ
                 MOVWF           POWER
                 MOVWF           CCPR1L             ; 
                 CALL            REWRITE            ; 1...3
SEC05            BTFSS           INTCON,T0IF        ;   0
                 GOTO            ENDCLOCK
                 BCF             INTCON,T0IF
                 DECFSZ          DEL1,F
                 GOTO            ENDCLOCK
M5               MOVLW           08
                 MOVWF           DEL1
                 BTFSS           PORTB,1
                 GOTO            M6                 ; SB4
                 INCF            POWER,F
                 MOVF            POWER,W
                 SUBLW           H'B5'
                 BTFSC           STATUS,Z
                 DECF            POWER,F
                 MOVF            MODE,W
                 MOVWF           ADR
                 DECF            ADR,F
                 MOVF            POWER,W
                 MOVWF           CCPR1L
                 CALL            SAVE
                 CALL            REWRITE
M6               BTFSS           PORTB,2
                 GOTO            ENDCLOCK           ; SB5
                 DECF            POWER,F
                 BTFSC           STATUS,Z
                 INCF            POWER,F
                 MOVF            MODE,W
                 MOVWF           ADR
                 DECF            ADR,F
                 MOVF            POWER,W
                 MOVWF           CCPR1L
                 CALL            SAVE
                 CALL            REWRITE
ENDCLOCK         SWAPF           STATUS_TMP,W       ;  
                 MOVWF           STATUS
                 SWAPF           W_TMP,F
                 SWAPF           W_TMP,W
                 RETFIE
;
SAVE             BCF             PIR1,EEIF          ;  EEPROM   ADR  W
                 MOVWF           W_TMP2
                 MOVF            ADR,W
                 BSF             STATUS,RP0
                 MOVWF           EEADR
                 BCF             STATUS,RP0
                 MOVF            W_TMP2,W
                 BSF             STATUS,RP0
                 MOVWF           EEDATA
                 BSF             EECON1,WREN
                 MOVLW           H'55'
                 MOVWF           EECON2
                 MOVLW           H'AA'
                 MOVWF           EECON2
                 BSF             EECON1,WR
                 BCF             STATUS,RP0         
WAIT1            BTFSS           PIR1,EEIF          ;  
                 GOTO            WAIT1              ; 
;
                 MOVF            ADR,W
                 BSF             STATUS,RP0         ; 
                 MOVWF           EEADR
                 BSF             EECON1,RD
                 MOVF            EEDATA,W
                 BCF             STATUS,RP0
                 SUBWF           W_TMP2,W
                 BTFSS           STATUS,Z
                 GOTO            SAVE
;
                 BSF             STATUS,RP0
                 BCF             EECON1,WREN
                 BCF             STATUS,RP0
                 RETURN
                 END
                 
                 

